/***************************************************************************
 *   Copyright (C) 2008 by dr Linh Anh Nguyen                              *
 *   Institute of Informatics, University of Warsaw                        *
 *   nguyen@mimuw.edu.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _GENERATOR_H
#define _GENERATOR_H

#include <stdio.h>

typedef struct {
  unsigned int randomSeed;
  unsigned int numOfRoles;
  unsigned int numOfAtomicConcepts;
  unsigned int numOfConcepts;

  // the 5 following attributes should sum up to 100 (%).
  unsigned int probabilityAND;
  unsigned int probabilityOR;
  unsigned int probabilityALL;
  unsigned int probabilitySOME;
  unsigned int probabilityNOT;
  unsigned int probabilityDUPL;

  // the following attributes belong to the range 0..1
  // where the lower bound is less than the corresponding upper bound
  float firstArgIndexLowerBound;
  float firstArgIndexUpperBound;
  float secondArgIndexLowerBound;
  float secondArgIndexUpperBound;

} AlcTBoxGenType;

class AlcTBoxGen {
  public:
    static void writeParams(AlcTBoxGenType *gtype, FILE *pf);
    static void generateTBox(AlcTBoxGenType *gtype, FILE *pf);
};

#endif
