/***************************************************************************
 *   Copyright (C) 2008 by dr Linh Anh Nguyen                              *
 *   Institute of Informatics, University of Warsaw                        *
 *   nguyen@mimuw.edu.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _MINDEX_H
#define _MINDEX_H

#include <string>
#include <map>
#include <iostream>
#include <stdio.h>

class ModalIndex 
{
  public:
    virtual void display(FILE *f) = 0;
    virtual void display() = 0;
    virtual int getWeight() = 0;
    virtual int getSize() = 0;
};

//------------------------------------------------------------------------------

class ModalIndexSym : public ModalIndex {
  protected:
    string *value;

  public:
    ModalIndexSym(string* _value) { value = _value; };
    ModalIndexSym* representative();
    void display(FILE *f) { fprintf(f, "%s", value->c_str()); };
    void display() { cout << value->c_str(); };
    int getWeight() { return 1; };
    int getSize() { return 1; };
};

class ModalIndexSymCat {
  private:
    static map<string*,ModalIndexSym*> indices;
  public:
    static ModalIndexSym* find(string *s);
};

//------------------------------------------------------------------------------

class ModalIndexNum : public ModalIndex {
  protected:
    int value;

  public:
    ModalIndexNum(int _value) { value = _value; };
    ModalIndexNum* representative();
    void display(FILE *f) { fprintf(f, "%d", value); };
    void display() { cout << value; };
    int getWeight() { return 1; };
    int getSize() { return 1; };
};

class ModalIndexNumCat {
  private:
    static map<int,ModalIndexNum*> indices;
  public:
    static ModalIndexNum* find(int k);
};

#endif
