/***************************************************************************
 *   Copyright (C) 2008 by dr Linh Anh Nguyen                              *
 *   Institute of Informatics, University of Warsaw                        *
 *   nguyen@mimuw.edu.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _UTILS_H
#define _UTILS_H

#include <set>
#include <iostream>
#include <stdio.h>
#include <stdint.h>
#include "first.h"

#define MSG(msg) { cout << msg << "\n"; }

#define ASSERT(cond) { \
	if (!(cond)) { \
	  cout << "Assertion failed at file " << __FILE__ << \
		" and line " << __LINE__ << "." << endl; \
	  exit(-1); \
	}; \
}

#ifdef DEBUG
#define assert(cond) { \
	if (!(cond)) { \
	  cout << "Assertion failed at file " << __FILE__ << \
		" and line " << __LINE__ << "." << endl; \
	  exit(-1); \
	}; \
}
#define DEBUG_MARK() 	{ cout << "DEBUG POSITION: " << __FILE__ << " " << __LINE__ << ".\n\n"; }
#define DEBUG_EXP() 	( cout << "DEBUG POSITION: " << __FILE__ << " " << __LINE__ << ".\n\n" )
#define DEBUG_MSG(msg) 	{ cout << msg << "\n\n"; }
#else
#define assert(cond) 	{}
#define DEBUG_MARK()	{}
#define DEBUG_EXP()	()
#define DEBUG_MSG(msg)	{}
#endif

#ifdef VERBOSE
#define VERBOSE_MSG(msg) { cout << msg << "\n"; }
#else
#define VERBOSE_MSG(msg) {}
#endif

#define UNSUPPORTED() { cout << "\nCalling an unsupported method.\n"; exit(-1); }

//------------------------------------------------------------------------------

#ifdef DEBUG1
#define DEBUG1_MARK() { cout << "DEBUG POSITION: " << __FILE__ << " " << __LINE__ << ".\n\n"; }
#else
#define DEBUG1_MARK() {}
#endif

#ifdef DEBUG2
#define DEBUG2_MARK() { cout << "DEBUG POSITION: " << __FILE__ << " " << __LINE__ << ".\n\n"; }
#else
#define DEBUG2_MARK() {}
#endif

#ifdef DEBUG3
#define DEBUG3_MARK() { cout << "DEBUG POSITION: " << __FILE__ << " " << __LINE__ << ".\n\n"; }
#else
#define DEBUG3_MARK() {}
#endif

#ifdef DEBUG4
#define DEBUG4_MARK() { cout << "DEBUG POSITION: " << __FILE__ << " " << __LINE__ << ".\n\n"; }
#else
#define DEBUG4_MARK() {}
#endif

#ifdef DEBUG5
#define DEBUG5_MARK() { cout << "DEBUG POSITION: " << __FILE__ << " " << __LINE__ << ".\n\n"; }
#else
#define DEBUG5_MARK() {}
#endif

//------------------------------------------------------------------------------

uint32_t hashword(int type);
uint32_t hashword(int type, uint32_t x);
uint32_t hashword(int type, uint32_t x, uint32_t y);
uint32_t hashword(int type, set<Formula*> &s);

//------------------------------------------------------------------------------

unsigned floor_log2(unsigned k);
unsigned ceil_log2(unsigned k);

#endif
